unit milibreria;
{$include ..\MiLibreria\mismacros.pas}
interface
uses
  windows, cmem, sysutils, commctrl;
function FindFirstFileExW(p1:PWideChar;p2:_FINDEX_INFO_LEVELS;p3:PVOID;p4:_FINDEX_SEARCH_OPS;p5:PVOID;p6:DWORD):HANDLE;stdcall;external 'kernel32.dll';
type
  fnTratarDatosListado = function(var ft:WIN32_FIND_DATAW;carpeta:PWideChar):BOOL;
procedure MiSetWindowClass(wc:PWNDCLASSEXW; estilo:UINT; wndproc:WNDPROC;
                           bigico:HICON;hcursor:HCURSOR;fondobrush:HBRUSH;
                           menuname:PWideChar;classname:PWideChar;
                           peqico:HICON);
procedure MiMostrarError(ficherror:WideString; lineaerror:WideString);
function MiBucleMensajes():LongInt;
procedure MiPonerFuenteGui(hw:HWND);
procedure MiGetThisExePath(ruta:PWideChar);
procedure MiPathAddBackSlash(cadena:PWideChar);
procedure MiListarDirectorio(carpeta:PWideChar;funcion:fnTratarDatosListado);
function MiMalloc(Tamanio:Uint):Pointer;
function MiReAlloc(puntero:Pointer;Tamanio:Uint):Pointer;
procedure Mifree(pun:Pointer);
procedure IniciarIdiomas();
procedure DestruirIdiomas();
function IdiomasObtenerTexto(Numero:DWORD):PWideChar;
procedure IdiomasEscoger(ventanaMadre:HWND);
procedure MiAjustarACliente(var ancho:Integer; var alto:Integer);
function Miwcslen(punt:PWideChar):Cardinal;
function Miisspace(car:WideChar):boolean;
function Mirtrim(pwc:PWideChar):PWideChar;
function Miwcsncpy(desti:PWideChar; source:PWideChar; numchars:Cardinal):PWideChar;
function Miwcscpy(desti:PWideChar; source:PWideChar):PWideChar;
function Miltrim(source:PWideChar):PWideChar;
function Mitrim(source:PWideChar):PWideChar;
function Miwcscat(desti:PWideChar; source:PWideChar):PWideChar;
function Miwcscmp(cad1:PWideChar; cad2:PWideChar):Integer;
procedure Misetmem(pun:pbyte;lon:Cardinal;valor:byte);
procedure MiZeroMemory(pun:pbyte;lon:Cardinal);
procedure MiIniciarControlesComunes();
implementation
type
 LANGITS = record
    langIt : PWideChar;
    numero : DWORD;
 end;
 PLANGITS = ^LANGITS;
var
   hayfich : boolean;
   nombrefich:Array[0..MIMAXPATH] of WideChar;
   numcadenas : Integer;
   langs :  PLANGITS;
   hcombobox : HWND;
procedure MiPonerFuenteGui(hw:HWND);
var hf:HFONT;
begin
  hf := GetStockObject(DEFAULT_GUI_FONT);
  if hf = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  SendMessageW(hw, WM_SETFONT, hf, LPARAM(TRUE));
end;
function MiBucleMensajes():LongInt;
var
  msge:MSG;
  ret:LongInt;
begin
  ret := LongInt(GetMessage(@msge, 0, 0, 0));
  while ret <> 0 do
  begin
    if ret = -1 then
      MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
    TranslateMessage(@msge);
    DispatchMessage(@msge);
    ret := LongInt(GetMessage(@msge, 0, 0, 0));
  end;
  Exit(LongInt(msge.wParam));
end;
procedure MiSetWindowClass(wc:PWNDCLASSEXW; estilo:UINT; wndproc:WNDPROC;
                           bigico:HICON;hcursor:HCURSOR;fondobrush:HBRUSH;
                           menuname:PWideChar;classname:PWideChar;
                           peqico:HICON);
var
  hi:HMODULE;
begin
  hi := GetModuleHandle(nil);
  if hi = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  ZeroMemory(wc, sizeof(WNDCLASSEXW));
  wc^.cbSize := sizeof(WNDCLASSEXW);
  wc^.style := estilo;
  wc^.lpfnWndProc:= wndproc;
  wc^.hInstance := hi;
  wc^.hIcon:=bigico;
  wc^.hCursor:=hcursor;
  wc^.hbrBackground:=fondobrush;
  wc^.lpszMenuName:= menuname;
  wc^.lpszClassName:=classname;
  wc^.hIconSm:=peqico;
  if RegisterClassExW(wc) = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
end;
procedure MiMostrarError(ficherror:WideString; lineaerror:WideString);
  var cadena:array [0..400] of WideChar;
begin
  Miwcscpy(PWideChar(cadena), IdiomasObtenerTexto(21));
  Miwcscat(PWideChar(cadena), WideString(#13 +  #10));
  Miwcscat(PWideChar(cadena), PWideChar(lineaerror));
  Miwcscat(PWideChar(cadena), WideString(#13 +  #10));
  Miwcscat(PWideChar(cadena), IdiomasObtenerTexto(22));
  Miwcscat(PWideChar(cadena), WideString(#13 +  #10));
  Miwcscat(PWideChar(cadena), PWideChar(ficherror));
  MessageBoxW(0, PWideChar(cadena), IdiomasObtenerTexto(23),  MB_OK or MB_ICONERROR);
  ExitProcess(0);
end;
procedure MiGetThisExePath(ruta:PWideChar);
var
  rut:Array[0..MIMAXPATH] of WideChar;
  x:Integer;
begin
  if GetModuleFileNameW(0, PWideChar(rut), MIMAXPATH) = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  for x := lstrlenW(rut) downto 1  do
  begin
    if rut[x - 1] = WideChar('\') then
      break;
  end;
  rut[x - 1] := WideChar(0);
  lstrcpyW(ruta, rut);
end;
procedure MiPathAddBackSlash(cadena:PWideChar);
var
  puntero:PWideChar;
begin
    puntero := cadena;
    while (puntero^) <> WideChar(0) do
        inc(puntero);
    if puntero = cadena then
    begin
        (puntero^) := WideChar('\');
        inc(puntero);
        puntero^ := WideChar(0);
        exit;
    end;
    dec(puntero);
    if (puntero^) = WideChar('\') then
        exit;
    inc(puntero);
    puntero^ := WideChar('\');
    inc(puntero);
    puntero^ := WideChar(0);
end;
procedure MiListarDirectorio(carpeta:PWideChar;funcion:fnTratarDatosListado);
var
  h:HANDLE;
  cad:Array[0..MIMAXPATH] of WideChar;
  b:BOOL;
  fd:WIN32_FIND_DATAW;
begin
  Miwcscpy(cad, WideString('\\?\'));
  Miwcscat(cad, carpeta);
  MiPathAddBackSlash(cad);
  Miwcscat(cad, WideString('*'));
  h := FindFirstFileExW(cad, FindExInfoStandard, @fd, FindExSearchNameMatch, nil, 0);
  if h = INVALID_HANDLE_VALUE then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  if funcion(fd, carpeta) = TRUE then
  begin
      if windows.FindClose(h) = FALSE then
         MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
      exit();
  end;
  b := FindNextFileW(h, @fd);
  while b <> FALSE do
  begin
    if funcion(fd, carpeta) = TRUE then
    begin
        if windows.FindClose(h) = FALSE then
           MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
        exit();
    end;
    b := FindNextFileW(h, @fd);
  end;
  if GetLastError() <> ERROR_NO_MORE_FILES then
      MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  if windows.FindClose(h) = FALSE then
     MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
end;
function MiMalloc(Tamanio:Uint):Pointer;
var puntero:Pointer;
begin
     puntero := malloc(Tamanio);
     if puntero = nil then
        MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
     Exit (puntero);
end;
function MiReAlloc(puntero:Pointer;Tamanio:Uint):Pointer;
begin
  puntero := realloc(puntero, Tamanio);
  if puntero = nil then
     MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  Exit(puntero);
end;
procedure getlangpath(path:PWideChar);
 begin
      MiGetThisExePath(path);
      MiPathAddBackSlash(path);
      lstrcatW(path, WideString('lang'));
 end;
function tratarlistado(var fd:WIN32_FIND_DATAW;carpeta:PWideChar):BOOL;
begin
    if (fd.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
        exit(FALSE);
    if lstrlenW(fd.cFileName) < 10 then
        exit(FALSE);
    if fd.cFileName[0] <> WideChar('_') then
        exit(FALSE);
    if lstrcmpW(@fd.cFileName[lstrlenW(fd.cFileName) - 9], WideString('.lang.txt')) <> 0 then
        exit(FALSE);
    lstrcpyW(nombrefich, fd.cFileName);
    hayfich := TRUE;
    exit(TRUE);
end;
procedure obtenerfichero(carpeta:PWideChar);
begin
    hayfich := FALSE;
    MiListarDirectorio(carpeta, @tratarlistado);
    if hayfich = FALSE then
        MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
    MiPathAddBackSlash(carpeta);
    lstrcatW(carpeta, nombrefich);
end;
procedure leerfichero(fichero:PWideChar);
var
  pact:PWideChar;
  numero:PWideChar;
  texto:PWideChar;
  fich:File of WideChar;
  x:DWORD;
  ch:WideChar;
begin
    numcadenas := 0;
    langs := nil;
    pact := MiMalloc(4000000);
    numero := MiMalloc(4000000);
    texto := MiMalloc(4000000);
    Assign(fich, fichero);
    Reset(fich);
    while 1 = 1 do
    begin
      ch := WideChar(' ');
      x := 0;
      while ((eof(fich) = false) and (ch <> WideChar(10))) do
      begin
         Read(fich, ch);
         pact[x] := ch;
         inc(x);
      end;
      if ch = WideChar(10) then
      begin
      pact[x] := WideChar(0);
      if Word(pact[0]) = $FEFF then
          lstrcpyW(@pact[0], @pact[1]);
      if pact[lstrlenW(pact) - 1] = WideChar(10) then
      begin
          if pact[lstrlenW(pact) - 2] = WideChar(13) then
          begin
              pact[lstrlenW(pact) - 2] := WideChar(0);
          end;
      end;
      if lstrlenW(pact) < 2 then
         continue;
      langs := MiReAlloc(langs, (numcadenas + 1) * (sizeof(LANGITS)));
      numero[0] := WideChar(0);
      texto[0] := WideChar(0);
      x := 0;
      while (pact[x] <> WideChar('=')) and (x < 1999999) do
      begin
        numero[x] := pact[x];
        inc(x);
      end;
      numero[x] := WideChar(0);
      lstrcpyW(texto, @pact[x + 1]);
      langs[numcadenas].langIt := MiMalloc((lstrlenW(texto) + 1) * sizeof(WideChar));
      lstrcpyW(langs[numcadenas].langIt, texto);
      val(WideString(numero), langs[numcadenas].numero);
      x := langs[numcadenas].numero;
      if langs[numcadenas].numero = 0 then
         MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
      inc(numcadenas);
      end;
      if eof(fich) then
      begin
          Close(fich);
          free(pact);
          free(numero);
          free(texto);
          exit();
      end;
    end;
end;
 procedure IniciarIdiomas();
 var
   ruta:array[0..MIMAXPATH] of WideChar;
 begin
    getlangpath(ruta);
    obtenerfichero(ruta);
    leerfichero(ruta);
end;
procedure DestruirIdiomas();
var x:DWORD;
begin
     for x := 0 to numcadenas - 1 do
         free (langs[x].langIt);
     free(langs);
     langs := nil;
     numcadenas := 0;
end;
function IdiomasObtenerTexto(Numero:DWORD):PWideChar;
var x:DWORD;
begin
    if numcadenas = 0 then
      MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
    for x := 0 to numcadenas - 1 do
    begin
         if langs[x].numero = Numero then
             Exit(langs[x].langIt);
    end;
    Exit(PWideChar('none'));
end;
function IdiomasOnDestroy(hwn:HWND;wpar:WPARAM;lpar:LPARAM):LRESULT;
begin
  PostQuitMessage(0);
  Exit(0);
end;
function tratarlistadoficheros(var fd:WIN32_FIND_DATAW;carpeta:PWideChar):BOOL;
var cadena:array[0..2599] of WideChar;
begin
  if (fd.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
    Exit(FALSE);
  while ((fd.cFileName[0] = WideChar('_')) and (lstrlenW(fd.cFileName) > 0)) do
    lstrcpyW(PWideChar(@fd.cFileName[0]), PWideChar(@fd.cFileName[1]));
  if lstrlenW(fd.cFileName) < 10 then
    Exit(FALSE);
  if lstrcmpW(PWideChar(@fd.cFileName[lstrlenW(fd.cFileName) - 9]), WideString('.lang.txt')) <> 0 then
    Exit(FALSE);
  lstrcpyW(PWideChar(cadena), fd.cFileName);
  cadena[lstrlenW(cadena) - 9] := WideChar(0);
  if SendMessageW(hcombobox, CB_ADDSTRING, 0, LPARAM(PWideChar(cadena))) = CB_ERR then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  Exit(FALSE);
end;
procedure IdiomasLlenarCombobox();
var ruta:array[0..2599] of WideChar;
begin
  getlangpath(PWideChar(ruta));
  MiListarDirectorio(PWideChar(ruta), @tratarlistadoficheros);
  if SendMessageW(hcombobox, CB_SETCURSEL, 0, 0) = CB_ERR then
        MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
end;
function IdiomasOnCreate(hwn:HWND;wpar:WPARAM;lpar:LPARAM):LRESULT;
var
  hi:HANDLE;
  hwi:HWND;
begin
  hi := GetModuleHandle(nil);
  hwi := CreateWindowExW(0, WideString('button'),
      IdiomasObtenerTexto(28),
      WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_PUSHBUTTON,
      25, 25 * 3, 250 - (25 * 2),
      25, hwn, HMENU(10001), hi, nil);
  MiPonerFuenteGui(hwi);
  hcombobox := CreateWindowExW(0, WideString('combobox'),
      WideString(''),
      WS_CHILD or WS_VISIBLE or WS_TABSTOP or CBS_DROPDOWNLIST or CBS_SORT,
      25, 25, 250 - (25 * 2),
      25 * 5, hwn, HMENU(10000), hi, nil);
  MiPonerFuenteGui(hcombobox);
  IdiomasLlenarCombobox();
  Exit(0);
end;
function quitarsubrayadolistadoficheros(var fd:WIN32_FIND_DATAW;carpeta:PWideChar):BOOL;
var cadena:array[0..2599] of WideChar;
var cadena2:array[0..2599] of WideChar;
begin
  if (fd.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
    Exit(FALSE);
  if lstrlenW(fd.cFileName) < 10 then
    Exit(FALSE);
  if lstrcmpW(@fd.cFileName[lstrlenW(fd.cFileName) - 9], WideString('.lang.txt')) <> 0 then
    Exit(FALSE);
  lstrcpyW(cadena, WideString('\\?\'));
  lstrcatW(cadena, carpeta);
  MiPathAddBackSlash(cadena);
  lstrcpyW(cadena2, cadena);
  lstrcatW(cadena2, fd.cFileName);
  while (fd.cFileName[0] = WideChar('_')) and (lstrlenW(fd.cFileName) > 0) do
    lstrcpyW(@fd.cFileName[0], @fd.cFileName[1]);
  lstrcatW(cadena, fd.cFileName);
  if MoveFileW(cadena2, cadena) = false then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  Exit(FALSE);
end;
function ponersubrayadolistadoficheros(var fd:WIN32_FIND_DATAW;carpeta:PWideChar):BOOL;
var cadena:array[0..2599] of WideChar;
var cadena2:array[0..2599] of WideChar;
var cadena3:array[0..2599] of WideChar;
begin
  if (fd.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
    Exit(FALSE);
  if lstrlenW(fd.cFileName) < 10 then
    Exit(FALSE);
  if lstrcmpW(@fd.cFileName[lstrlenW(fd.cFileName) - 9], WideString('.lang.txt')) <> 0 then
    Exit(FALSE);
  lstrcpyW(cadena2, WideString('\\?\'));
  lstrcatW(cadena2, carpeta);
  MiPathAddBackSlash(cadena2);
  lstrcatW(cadena2, fd.cFileName);
  lstrcpyW(cadena3, fd.cFileName);
  cadena3[lstrlenW(fd.cFileName) - 9] := WideChar(0);
  while ((cadena3[0] = WideChar('_')) and (lstrlenW(cadena3) > 0)) do
    lstrcpyW(@cadena3[0], @cadena3[1]);
  SendMessageW(hcombobox, WM_GETTEXT, 2599, LPARAM(PWideChar(cadena)));
  if lstrcmpW(cadena, cadena3) <> 0 then
    Exit(FALSE);
  lstrcpyW(cadena, WideString('\\?\'));
  lstrcatW(cadena, carpeta);
  MiPathAddBackSlash(cadena);
  lstrcatW(cadena, WideString('_'));
  lstrcatW(cadena, fd.cFileName);
  if MoveFileW(cadena2, cadena) = false then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
end;
function IdiomasOnCommand(hwn:HWND;wpar:WPARAM;lpar:LPARAM):LRESULT;
var ruta:array[0..2599] of WideChar;
begin
  if LOWORD(wpar) = 10001 then
  begin
    getlangpath(PWideChar(ruta));
    MiListarDirectorio(PWideChar(ruta), @quitarsubrayadolistadoficheros);
    MiListarDirectorio(PWideChar(ruta), @ponersubrayadolistadoficheros);
    MessageBoxW(hwn, IdiomasObtenerTexto(29), WideString(''), MB_OK OR MB_ICONINFORMATION);
    DestroyWindow(hwn);
    Exit(0);
  end;
end;
function IdiomasFuncProc(hwn:HWND;mensaje:UINT;wpar:WPARAM;lpar:LPARAM):LRESULT;stdcall;
begin
  if mensaje = WM_DESTROY then
    Exit(IdiomasOnDestroy(hwn, wpar, lpar));
  if mensaje = WM_CREATE then
    Exit(IdiomasOnCreate(hwn, wpar, lpar));
  if mensaje = WM_COMMAND then
    Exit(IdiomasOnCommand(hwn, wpar, lpar));
  Exit(DefWindowProcW(hwn, mensaje, wpar, lpar));
end;
procedure IdiomasEscoger(ventanaMadre:HWND);
var
  hig:HICON;
  hip:HICON;
  hcur:HCURSOR;
  wce:WNDCLASSEXW;
  hi:HANDLE;
  hwn:HWND;
  Cn:array[0..100] of WideChar;
begin
  lstrcpyW(Cn, PWideChar(WideString('IdiomasClass1')));
  EnableWindow(ventanaMadre, FALSE);
  hig := LoadIconW(0, PWideChar(32516));
  if hig = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  hip := LoadIconW(0, PWideChar(32516));
  if hip = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  hcur := LoadCursorW(0, PWideChar(IDC_ARROW));
  if hcur = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiSetWindowClass(@wce, CS_HREDRAW or CS_VREDRAW, @IdiomasFuncProc, hig,
                      hcur, HBRUSH(COLOR_BTNFACE + 1) , nil,
                      PWideChar(Cn), hip);
  hi := GetModuleHandle(nil);
  if hi = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  hwn := CreateWindowExW(0, Cn, IdiomasObtenerTexto(25),
                        WS_CAPTION or WS_SYSMENU,
                        CW_USEDEFAULT, CW_USEDEFAULT,
                        250, 150, ventanaMadre, 0,
                        hi, nil);
  MoveWindow(hwn,
             (GetSystemMetrics(SM_CXMAXIMIZED) - 250) div 2,
             (GetSystemMetrics(SM_CYMAXIMIZED) - 150) div 2,
             250, 150, TRUE);
  ShowWindow(hwn, SW_SHOW);
  MiBucleMensajes();
  UnregisterClassW(Cn, hi);
  EnableWindow(ventanaMadre, TRUE);
  SetForegroundWindow(ventanaMadre);
end;
procedure MiAjustarACliente(var ancho:Integer; var alto:Integer);
begin
  alto := alto + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics (SM_CYBORDER);
  ancho := (GetSystemMetrics(SM_CXBORDER) * 2) + ancho;
end;
function Miwcslen(punt:PWideChar):Cardinal;
var count:Cardinal;
begin
  count := 0;
  while punt^ <> WideChar(0) do
  begin
    inc(punt);
    inc(count);
  end;
  Exit(count);
end;
function Miisspace(car:WideChar):boolean;
begin
  if ((car = WideChar(32)) or (car = WideChar(10)) or (car = WideChar(13)) or (car = WideChar(12)) or (car = WideChar(11)) or (car = WideChar(9))) = true then
    Exit(true);
  Exit(false);
end;
function Mirtrim(pwc:PWideChar):PWideChar;
var lon:Integer;
var punt:PWideChar;
begin
  lon := Miwcslen(pwc);
  punt := pwc;
  punt := punt + lon;
  inc(lon);
  while ((lon > 0) and ((punt^ = WideChar(0)) or (Miisspace(punt^) = true))) = true do
  begin
    punt^ := WideChar(0);
    dec(punt);
    dec(lon);
  end;
  Exit(pwc);
end;
function Miwcsncpy(desti:PWideChar; source:PWideChar; numchars:Cardinal):PWideChar;
var pun:PWideChar;
begin
  pun := desti;
  while((numchars > 0) and (source^ <> WideChar(0)) = true) do
  begin
    dec(numchars);
    desti^ := source^;
    inc(desti);
    inc(source);
  end;
  desti^ := WideChar(0);
  Exit(pun);
end;
function Miwcscpy(desti:PWideChar; source:PWideChar):PWideChar;
begin
  Exit(Miwcsncpy(desti, source, Miwcslen(source)));
end;
function Miltrim(source:PWideChar):PWideChar;
var pt:PWideChar;
var ptr:PWideChar;
begin
  pt := Mimalloc((Miwcslen(source) + 1) * sizeof(WideChar));
  ptr := source;
  while Miisspace(ptr^) = true do
    inc(ptr);
  Miwcscpy(pt, ptr);
  Miwcscpy(source, pt);
  free(pt);
  Exit(source);
end;
function Mitrim(source:PWideChar):PWideChar;
begin
  Miltrim(source);
  Exit(Mirtrim(source));
end;
function Miwcscat(desti:PWideChar; source:PWideChar):PWideChar;
var pfin:PWideChar;
begin
  pfin := desti;
  pfin := pfin + Miwcslen(desti);
  Miwcscpy(pfin, source);
  Exit(desti);
end;
function Miwcscmp(cad1:PWideChar; cad2:PWideChar):Integer;
begin
  while cad1^ = cad2^ do
  begin
    if cad1^ = WideChar(0) then
      Exit(0);
    inc(cad1);
    inc(cad2);
  end;
  Exit(Integer(cad1^) - Integer(cad2^));
end;
procedure Mifree(pun:Pointer);
begin
  if pun <> nil then
     free(pun);
end;
procedure Misetmem(pun:pbyte;lon:Cardinal;valor:byte);
begin
  while lon > 0 do
  begin
    pun^ := valor;
    inc(pun);
    dec(lon);
  end;
end;
procedure MiZeroMemory(pun:pbyte;lon:Cardinal);
begin
  Misetmem(pun, lon, Byte(0));
end;
procedure MiIniciarControlesComunes();
var icce:tagINITCOMMONCONTROLSEX;
begin
  icce.dwSize := sizeof(tagINITCOMMONCONTROLSEX);
  icce.dwICC := ICC_WIN95_CLASSES;
  if InitCommonControlsEx(icce) = FALSE then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
end;

end.
